function a4 (a,b,x0)

maxiter = 1000;


[m, rhs, A] = example_3 (a,b);         % load constants, etc.



% $$$ B = [  1  1  1 1; 
% $$$       -1  1  1 1;
% $$$        1 -1  1 1;
% $$$        1  1 -1 1 ];
% $$$ 
% $$$ D = [ 1 12 25 17 ];
% $$$ A = B'*diag(D)*B;
% $$$ 
% $$$ b = [ 1 1 1 1 ]';

% $$$ A  = [ 2 0 ; 0 10 ];
% $$$ b  = [ 0; 0];
% $$$ x0 = [ 4; sqrt(1.8) ];


% $$$ keyboard

eps = 1e-14;

r   = zeros (m, 1 );
k   = 0;
x   = x0;

p = rhs - A * x0;
r = p;
alpha = norm( r )^2;

while ( (alpha > eps) & (k < maxiter) )
  
  v = A * p;
  lambda = alpha / (v'*p);
  x = x + lambda * p;
  
  r = r - lambda * v;
  
  alphanew = norm( r )^2;
  
  p = r + alphanew/alpha*p;
  alpha = alphanew;
  
  
  fprintf ('%4i\t%21.12e\n', k, alpha);

  k = k + 1;
end
